Package com.fasterxml.jackson.core

# Interface PrettyPrinter

All Known Implementing Classes:
  `DefaultPrettyPrinter`, `MinimalPrettyPrinter`

public interface PrettyPrinter
Interface for objects that implement pretty printer functionality, such as indentation. Pretty printers are used to add white space in output JSON content, to make results more human readable. Usually this means things like adding linefeeds and indentation.

Note: since Jackson 2.1, stateful implementations MUST implement `Instantiatable` interface, to allow for constructing per-generation instances and avoid state corruption. Stateless implementations need not do this; but those are less common.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final SerializedString`
`DEFAULT_ROOT_VALUE_SEPARATOR`
Default String used for separating root values is single space.
`static final Separators`
`DEFAULT_SEPARATORS`

## Method Summary

Modifier and Type
Method
Description
`void`
`beforeArrayValues(JsonGenerator gen)`
Method called after array start marker has been output, and right before the first value is to be output.
`void`
`beforeObjectEntries(JsonGenerator gen)`
Method called after object start marker has been output, and right before the field name of the first entry is to be output.
`void`
`writeArrayValueSeparator(JsonGenerator gen)`
Method called after an array value has been completely output, and before another value is to be output.
`void`
`writeEndArray(JsonGenerator gen, int nrOfValues)`
Method called after an Array value has been completely output (minus closing bracket).
`void`
`writeEndObject(JsonGenerator gen, int nrOfEntries)`
Method called after an Object value has been completely output (minus closing curly bracket).
`void`
`writeObjectEntrySeparator(JsonGenerator gen)`
Method called after an Object entry (field:value) has been completely output, and before another value is to be output.
`void`
`writeObjectFieldValueSeparator(JsonGenerator gen)`
Method called after an object field has been output, but before the value is output.
`void`
`writeRootValueSeparator(JsonGenerator gen)`
Method called after a root-level value has been completely output, and before another value is to be output.
`void`
`writeStartArray(JsonGenerator gen)`
Method called when an Array value is to be output, before any member/child values are output.
`void`
`writeStartObject(JsonGenerator gen)`
Method called when an Object value is to be output, before any fields are output.

## Field Details

### DEFAULT_SEPARATORS

static final Separators DEFAULT_SEPARATORS

Since:
  2.9

### DEFAULT_ROOT_VALUE_SEPARATOR

static final SerializedString DEFAULT_ROOT_VALUE_SEPARATOR
Default String used for separating root values is single space.

Since:
  2.9

## Method Details

### writeRootValueSeparator

void writeRootValueSeparator(JsonGenerator gen) throws IOException
Method called after a root-level value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a space, to allow values to be parsed correctly. Pretty-printer is to output some other suitable and nice-looking separator (tab(s), space(s), linefeed(s) or any combination thereof).

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeStartObject

void writeStartObject(JsonGenerator gen) throws IOException
Method called when an Object value is to be output, before any fields are output.

Default handling (without pretty-printing) will output the opening curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeEndObject

void writeEndObject(JsonGenerator gen, int nrOfEntries) throws IOException
Method called after an Object value has been completely output (minus closing curly bracket).

Default handling (without pretty-printing) will output the closing curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Parameters:
  `gen` - Generator used for output
  `nrOfEntries` - Number of direct members of the Object that have been output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeObjectEntrySeparator

void writeObjectEntrySeparator(JsonGenerator gen) throws IOException
Method called after an Object entry (field:value) has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeObjectFieldValueSeparator

void writeObjectFieldValueSeparator(JsonGenerator gen) throws IOException
Method called after an object field has been output, but before the value is output.

Default handling (without pretty-printing) will output a single colon to separate the two. Pretty-printer is to output a colon as well, but can surround that with other (white-space) decoration.

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeStartArray

void writeStartArray(JsonGenerator gen) throws IOException
Method called when an Array value is to be output, before any member/child values are output.

Default handling (without pretty-printing) will output the opening bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeEndArray

void writeEndArray(JsonGenerator gen, int nrOfValues) throws IOException
Method called after an Array value has been completely output (minus closing bracket).

Default handling (without pretty-printing) will output the closing bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Parameters:
  `gen` - Generator used for output
  `nrOfValues` - Number of direct members of the array that have been output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeArrayValueSeparator

void writeArrayValueSeparator(JsonGenerator gen) throws IOException
Method called after an array value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### beforeArrayValues

void beforeArrayValues(JsonGenerator gen) throws IOException
Method called after array start marker has been output, and right before the first value is to be output. It is not called for arrays with no values.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### beforeObjectEntries

void beforeObjectEntries(JsonGenerator gen) throws IOException
Method called after object start marker has been output, and right before the field name of the first entry is to be output. It is not called for objects without entries.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Parameters:
  `gen` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer